import os, pwd
def main():

	rootpath='/srv/darknet-onion-webring/'
	urlpath=pwd.getpwuid(os.getuid()).pw_dir+"/.darknet_participant_url"
	print(urlpath)
	isitvalid="n"

	#check if ~/.darknet_participant_url exists,
	# if exists, instance= the content of ~/.darknet_participant_url (which is the url: such as uptime.nowherejez...onion)

	while isitvalid != "y":
		if os.path.isfile(urlpath):
			with open(urlpath) as f:
				instance = f.read()
			# TODO check if the instance URL domain is valid
			instancepath=rootpath+'www/participants/'+instance
			print("[+] file exists, your Webring URL is ", instance)
			isitvalid = "y"
		else:
			print("[+] Instance Path doesn't exist yet")
			# and ask for the instance URL domain 
			instance = input("What is your Instance domain ? (ex: uptime.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion):")
			instancepath=rootpath+'www/participants/'+instance
			# TODO check if the instance URL domain is valid
			
			# ask the user if the instance URL is valid ? 
			print()
			print(instance)
			isitvalid=input("Is your this your instance domain ?")
			# if yes, then write it into ~/.darknet_participant_url
			if isitvalid != "y" :
				print("OK writing the instance url to ~/.darknet_participants_url")
				with open(urlpath, "w") as file:
					file.write(instance)
			    print("[+] file written, let's read it")
			    f = open(urlpath,"r")
			    print(f.read())
			    print("[+] Initial Setup Completed!")
			
	print("[+] Welcome to the Darknet Onion Webring, where you are exploring the Darknet and helping others do the same.")
	print("""
 1) Add a new entry (into unverified.csv) 
 2) Verify an entry (move an entry from unverified to verified.csv) 
 3) Add a new webring participant (and download their files into their directory (without trusting them yet!))
 4) Trust a webring participant (Potentially dangerous)
 5) Add/Remove words in the sensitive list (ex: drug)
 6) Add/Remove words in the blacklist (ex: porn)
	""")
	option = input("Select Option? (1-4)")
	print(option)
	match option:
		case "1":
			print("[+] Add a new Entry (into unverified.csv)")
			# ask for the following:
			unverifiedpath=instancepath+'/unverified.csv'
				# the name of the website (required) + check if its valid
				entry_name = input("What is the Website name ?")
				# the url of the website (required) + check if its valid
				entry_url = input("What is URL of the Website ? (ex: https://torproject.org or http://2gzyxa5ihm7nsggfxnu52rck2vv4rvmdlkiu3zzui5du4xyclen53wid.onion")
				# a quick description (optional) + check if its valid
				entry_url = input("(Optional) Description of the website ? (max 256 characters) (press enter to skip)"
				# sensitive ? (y/n) + check if its valid
				entry_url = input("is it a sensitive website ? (ex: website related to drugs)"
				# (rest is automatic: status, score, instance is = '' because it is your own instance)
				# check if the entry doesn't already exist in verified.csv and in unverified.csv
				# if it doesnt exist, add it into unverified.csv

		case "2":
			print("[+] Verify an entry (move an entry from unverified.csv to verified.csv)")
			# search for a word 
			searchterm = input("What is the Website name ?")
			# and display only the matching entries in an array format (display it in CLI). 
			# Each of the rows must have an index,
			# prompt the user to ask for with row they want to move to verified.csv
			searchterm = input("What is the index of the entry that you want to move to verified.csv ?")
			# once selected, it must be able to print that row, and:
				# append it into verified.csv
				# remove it from unverified.csv
			# print("[+] completed! You are now listing [name] (url) (sensitive)")

		case "3":
			print("[+] Add a new webring participant (and download their files into their directory (without trusting them yet!))")
			# ask for the url to the other webring participant
			webring_participant_url = input("What is URL of the new webring participant? (ex: https://torproject.org or http://2gzyxa5ihm7nsggfxnu52rck2vv4rvmdlkiu3zzui5du4xyclen53wid.onion")
			# check if the (onion only) url is valid or not: at http://URL.onion/participants/URL.onion/{verified.csv,unverified.csv,sensitive.csv,blacklist.csv,webring-participants.csv}
			
		case "4":
			print("[+] Trust a webring participant (Potentially dangerous)")
			# list the existing webring participants from webring-participants.csv and 
			# ask the user to pick the index (0-9?) of the instance to trust
			# if index is valid, then mark the instance as trusted in webring-participants.csv
			searchterm = input("What is the index of the entry that you want to trust ?")
		case "5":
			print("[+] Add/Remove words in the sensitive list (ex: drug)")
			# print("do you want to 1) add words  or 2) remove words ?")
			# while option is not 1 or 2:
				# option=input("do you want to 1) add words  or 2) remove words ?")
			# done = False
			# while(done == False):
				# display the contents of sensitive.csv file
				# if option == 1: 
					# word=input("which word do you want to add? (write 0 to exit")
					# if word = 0 
						#then done= True to get out of the while loop
					# else
						#check if word is valid in a while loop (dont check if 
						# if invalid! remove word at index 
				#else:
					# index=input("which word do you want to remove? (index 0 to (max index) (write exit to exit)")
					# if index = exit 
						#then done= True to get out of the while loop
					# else
						# check if index is valid or not
							# if valid! remove word at index 
				
		case "6":
			print("[+] Add/Remove words in the blacklist list (ex: porn)")
			# copy option 5
			# print("do you want to 1) add words  or 2) remove words ?")
				# display the contents of blacklist.csv file
			
		case _:
			print("[-] ERROR, incorrect input")


def IsOnionValid(domain):
	# check if the characters are only [a-zA-Z0-9.] with maximum 128 chars max?
		# check that it is only url.onion or subdomain.url.onion,
			#  if OK return True
	#if not : return False
	return True

def IsUrlValid(url):
	# check if the characters are only [a-zA-Z0-9.:/] with maximum 128 chars max?
		# check that it is only http(s)://wordA.wordB or http(s)://WordC.WordB.WordC, (onion or not), clearnet is fine too (double check if those are fine!)
			#  if OK return True
	#if not : return False
	return True

def IsStatusValid(status):
	# check if the characters are only [vx] with maximum 1 chars max
		#  if OK return True
	#if not : return False
	return True

def IsDescriptionValid(desc):
	# check if the characters are only [a-zA-Z0-9.,' ] with maximum 256 chars max 
		#(careful with the ' and , make sure you test if it fucks the csv up or else)
		#  if OK return True
	#if not : return False
	return True

def IsCategoryValid(category):
	# check if the characters are only [a-zA-Z0-9 ] with maximum 64 chars max 
		#(careful with the ' and , make sure you test if it fucks the csv up or else)
		#  if OK return True
	#if not : return False
	return True

def IsNameValid(name):
	# check if the characters are only [a-zA-Z0-9 ] with maximum 64 chars max 
		#(careful with the ' and , make sure you test if it fucks the csv up or else)
		#  if OK return True
	#if not : return False
	return True




if __name__ == '__main__':
	main()
